> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.labric.co/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.labric.co/_mcp/server.

# Read

POST https://platform.labric.co/api/v1/tools/read
Content-Type: application/json

Read records from a table.

Returns records from the specified table matching the given filters.
Use 'single' mode to retrieve exactly one record, or 'multiple' mode
to retrieve all matching records.

Reference: https://docs.labric.co/api-reference/labric-api/tools/read

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: openapi-tools
  version: 1.0.0
paths:
  /api/v1/tools/read:
    post:
      operationId: read
      summary: Read
      description: |-
        Read records from a table.

        Returns records from the specified table matching the given filters.
        Use 'single' mode to retrieve exactly one record, or 'multiple' mode
        to retrieve all matching records.
      tags:
        - tools
      parameters:
        - name: Authorization
          in: header
          description: Bearer authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: array
                items:
                  type: object
                  additionalProperties:
                    description: Any type
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorSchema'
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorSchema'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorSchema'
        '404':
          description: Not Found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorSchema'
        '422':
          description: Unprocessable Content
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ValidationErrorSchema'
        '500':
          description: Internal Server Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorSchema'
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/LabricReadSchema'
servers:
  - url: https://platform.labric.co
    description: https://platform.labric.co
components:
  schemas:
    LabricReadSchemaTargetType:
      type: string
      enum:
        - table
        - core-table
      description: The type of target. Either 'table' or 'core-table'.
      title: LabricReadSchemaTargetType
    LabricReadSchemaMode:
      type: string
      enum:
        - single
        - multiple
      default: single
      description: >-
        'single' returns exactly one record and throws an error if more than one
        matching record exists, 'multiple' returns all matches.
      title: LabricReadSchemaMode
    LabricReadSchema:
      type: object
      properties:
        target_name:
          type: string
          description: The name of the table to read from.
        target_type:
          $ref: '#/components/schemas/LabricReadSchemaTargetType'
          description: The type of target. Either 'table' or 'core-table'.
        filters:
          type: object
          additionalProperties:
            description: Any type
          description: Key-value filters to apply to the query. Omit to match all records.
        mode:
          $ref: '#/components/schemas/LabricReadSchemaMode'
          default: single
          description: >-
            'single' returns exactly one record and throws an error if more than
            one matching record exists, 'multiple' returns all matches.
      required:
        - target_name
        - target_type
      description: Read records from a target table.
      title: LabricReadSchema
    ErrorSchema:
      type: object
      properties:
        detail:
          type: string
      required:
        - detail
      title: ErrorSchema
    ValidationErrorSchema:
      type: object
      properties:
        detail:
          type: array
          items:
            type: object
            additionalProperties:
              description: Any type
      required:
        - detail
      description: Shape of Ninja's built-in 422 request-validation error response.
      title: ValidationErrorSchema
  securitySchemes:
    ApiKeyAuth:
      type: http
      scheme: bearer

```

## Examples



**Request**

```json
{
  "target_name": "employees",
  "target_type": "table"
}
```

**Response**

```json
[
  {}
]
```

**SDK Code**

```python
import requests

url = "https://platform.labric.co/api/v1/tools/read"

payload = {
    "target_name": "employees",
    "target_type": "table"
}
headers = {
    "Authorization": "Bearer <api_key>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://platform.labric.co/api/v1/tools/read';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <api_key>', 'Content-Type': 'application/json'},
  body: '{"target_name":"employees","target_type":"table"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://platform.labric.co/api/v1/tools/read"

	payload := strings.NewReader("{\n  \"target_name\": \"employees\",\n  \"target_type\": \"table\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <api_key>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://platform.labric.co/api/v1/tools/read")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <api_key>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"target_name\": \"employees\",\n  \"target_type\": \"table\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://platform.labric.co/api/v1/tools/read")
  .header("Authorization", "Bearer <api_key>")
  .header("Content-Type", "application/json")
  .body("{\n  \"target_name\": \"employees\",\n  \"target_type\": \"table\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://platform.labric.co/api/v1/tools/read', [
  'body' => '{
  "target_name": "employees",
  "target_type": "table"
}',
  'headers' => [
    'Authorization' => 'Bearer <api_key>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://platform.labric.co/api/v1/tools/read");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <api_key>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"target_name\": \"employees\",\n  \"target_type\": \"table\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <api_key>",
  "Content-Type": "application/json"
]
let parameters = [
  "target_name": "employees",
  "target_type": "table"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://platform.labric.co/api/v1/tools/read")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```